## GtkSocket

GtkSocket — Container for widgets from other processes

## Functions

GtkWidget * | gtk_socket_new ()
void | gtk_socket_steal ()
void | gtk_socket_add_id ()
GdkNativeWindow | gtk_socket_get_id ()
GdkWindow * | gtk_socket_get_plug_window ()

## Signals

void | plug-added | Run Last
gboolean | plug-removed | Run Last

## Types and Values

struct | GtkSocket

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GtkObject
                ╰── GtkWidget
                    ╰── GtkContainer
                        ╰── GtkSocket

## Implemented Interfaces

GtkSocket implements AtkImplementorIface and GtkBuildable.

## Includes

    #include <gtk/gtk.h>

## Description

Together with GtkPlug, GtkSocket provides the ability to embed widgets from one process into another process in a fashion that is transparent to the user. One process creates a GtkSocket widget and passes that widget's window ID to the other process, which then creates a GtkPlug with that window ID. Any widgets contained in the GtkPlug then will appear inside the first application's window.

The socket's window ID is obtained by using `gtk_socket_get_id()`. Before using this function, the socket must have been realized, and for hence, have been added to its parent.

Example 59. Obtaining the window ID of a socket.

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10

    GtkWidget *socket = gtk_socket_new ();
    gtk_widget_show (socket);
    gtk_container_add (GTK_CONTAINER (parent), socket);

    /* The following call is only necessary if one of
     * the ancestors of the socket is not yet visible.
     */
    gtk_widget_realize (socket);
    g_print ("The ID of the sockets window is %<GTKDOCLINK HREF="x">x</GTKDOCLINK>\n",
             gtk_socket_get_id (socket));

Note that if you pass the window ID of the socket to another process that will create a plug in the socket, you must make sure that the socket widget is not destroyed until that plug is created. Violating this rule will cause unpredictable consequences, the most likely consequence being that the plug will appear as a separate toplevel window. You can check if the plug has been created by using `gtk_socket_get_plug_window()`. If it returns a non-`NULL` value, then the plug has been successfully created inside of the socket.

When GTK+ is notified that the embedded window has been destroyed, then it will destroy the socket as well. You should always, therefore, be prepared for your sockets to be destroyed at any time when the main event loop is running. To prevent this from happening, you can connect to the “plug-removed” signal.

The communication between a GtkSocket and a GtkPlug follows the

XEmbed

protocol. This protocol has also been implemented in other toolkits, e.g.

Qt, allowing the same level of integration

when embedding a Qt widget in GTK or vice versa.

A socket can also be used to swallow arbitrary pre-existing top-level windows using `gtk_socket_steal()`, though the integration when this is done will not be as close as between a GtkPlug and a GtkSocket.

The GtkPlug and GtkSocket widgets are currently not available on all platforms supported by GTK+.

## Functions

### gtk_socket_new ()

    GtkWidget *
    gtk_socket_new (void);

Create a new empty GtkSocket.

#### Returns

the new GtkSocket.

### gtk_socket_steal ()

    void
    gtk_socket_steal (GtkSocket *socket_,
                      GdkNativeWindow wid);

`gtk_socket_steal` is deprecated and should not be used in newly-written code.

Reparents a pre-existing toplevel window into a GtkSocket. This is meant to embed clients that do not know about embedding into a GtkSocket, however doing so is inherently unreliable, and using this function is not recommended.

The GtkSocket must have already be added into a toplevel window before you can make this call.

#### Parameters

socket_ | a GtkSocket |
wid | the window ID of an existing toplevel window. |

### gtk_socket_add_id ()

    void
    gtk_socket_add_id (GtkSocket *socket_,
                       GdkNativeWindow window_id);

Adds an XEMBED client, such as a GtkPlug, to the GtkSocket. The client may be in the same process or in a different process.

To embed a GtkPlug in a GtkSocket, you can either create the GtkPlug with `gtk_plug_new (0)`, call `gtk_plug_get_id()` to get the window ID of the plug, and then pass that to the `gtk_socket_add_id()`, or you can call `gtk_socket_get_id()` to get the window ID for the socket, and call `gtk_plug_new()` passing in that ID.

The GtkSocket must have already be added into a toplevel window before you can make this call.

#### Parameters

socket_ | a GtkSocket |
window_id | the window ID of a client participating in the XEMBED protocol. |

### gtk_socket_get_id ()

    GdkNativeWindow
    gtk_socket_get_id (GtkSocket *socket_);

Gets the window ID of a GtkSocket widget, which can then be used to create a client embedded inside the socket, for instance with `gtk_plug_new()`.

The GtkSocket must have already be added into a toplevel window before you can make this call.

#### Parameters

socket_ | a GtkSocket. |

#### Returns

the window ID for the socket

### gtk_socket_get_plug_window ()

    GdkWindow *
    gtk_socket_get_plug_window (GtkSocket *socket_);

Retrieves the window of the plug. Use this to check if the plug has been created inside of the socket.

#### Parameters

socket_ | a GtkSocket. |

#### Returns

the window of the plug if available, or `NULL`.

[transfer none]

Since 2.14

## Types and Values

### struct GtkSocket

    struct GtkSocket;

## Signal Details

### The `“plug-added”` signal

    void
    user_function (GtkSocket *socket_,
                   gpointer   user_data)

This signal is emitted when a client is successfully added to the socket.

#### Parameters

socket_ | the object which received the signal |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“plug-removed”` signal

    gboolean
    user_function (GtkSocket *socket_,
                   gpointer   user_data)

This signal is emitted when a client is removed from the socket. The default action is to destroy the GtkSocket widget, so if you want to reuse it you must add a signal handler that returns `TRUE`.

#### Parameters

socket_ | the object which received the signal |
user_data | user data set when the signal handler was connected. |

#### Returns

`TRUE` to stop other handlers from being invoked.

Flags: Run Last

## See Also

GtkPlug, XEmbed